#!/usr/bin/perl
use strict;
use warnings FATAL => qw(all);

use Sloop::Server;
use Sloop::Static;
use Sloop::WebSocket;

my $Sloop = Sloop::Server->new(port => 8080);
die if !$Sloop;

$Sloop->{handlers} = {
    '/' => sub {
    # The current working directory must contain
    # 'index.html' and 'websocket.js'.
        Sloop::Static::directory (
            shift,
            path => './',
        );
    },
    'websocket' => sub {
        my $client = shift;
        my $check = Sloop::WebSocket::start (
            $client,
            dataIn => sub {
            # Echo the data received back.
                my ($sender, $msgref) = (shift, shift);
                Sloop::WebSocket::sendFrame($sender, $msgref);
            }
        );
    }
};

$Sloop->run;
